Option Explicit

#include ..\lib\framework_domotics.vbs
#include local-parameters.inc

'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> regular memory check for each software
'-- PREREQUISITE: N/A
'-- PARAMS IN   : N/A
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 29/03/2007
'--------------------------------------------------------------------
Sub main
Dim astrDevices
Dim astrConfig
Dim atabDv
Dim astrNbDv
Dim i
Dim j
Dim astrDevice
Dim astrString
Dim astrRUN
Dim astrOUTPUT
Dim astrBuffer
Dim aintDATA
Dim astrPARAM1
Dim astrPARAM2
Dim atabLIST
Dim atabROWS
Dim atabDATA
Dim aDblRAM
Dim strComputer
Dim objWMIService
Dim colOperatingSystems
Dim objOS
Dim dtmBootup
Dim dtmLastBootupTime
Dim dtmSystemUptime
Dim strDays
Dim strHours
Dim strMinutes
Dim objMem

WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Launching " & G_FOLDER_NAME & " script", G_LOG_FILE
If CheckDevices(G_FOLDER_NAME, G_FILE_INI, G_STATUS_EXIST) Then
	astrDevices 		= hs.GetINISetting("COMMON","SOFTS","", G_FILE_INI)
	astrConfig  		= hs.GetINISetting("COMMON","CONFIG","..\scripts\config\", G_FILE_INI)
	atabDv	 			= Split(astrDevices, G_SEP)
	astrNbDv 			= UBound(atabDv) 
	i = 0
	While (i <= Cint(astrNbDv))
		astrDevice 			= hs.GetINISetting("DEVICE", "HC", "", astrConfig & atabDv(i)) & _ 
							  hs.GetINISetting("DEVICE", "DC", "", astrConfig & atabDv(i))
		astrPARAM1		    = hs.GetINISetting("DEVICE","PARAM1","",astrConfig & atabDv(i))	
		astrPARAM2		    = hs.GetINISetting("DEVICE","PARAM2","",astrConfig & atabDv(i))	

        astrRUN             = G_TMP_FOLDER & UCASE(astrPARAM2) & "_" & UCASE(astrPARAM1)& ".bat"
        astrOUTPUT          = G_TMP_FOLDER & astrPARAM1 & ".txt"
        astrString 	        = "Not launched"

        If UCASE(astrPARAM2)= "PSLIST" Then
            aintDATA        = isAlive(astrPARAM1)
            If (aintDATA = -1) or (aintDATA = 0) Then
                astrString 	= "Not launched"
            Else
                astrString 	= aintDATA
            End if

        Elseif UCASE(astrPARAM2) = "USEDRAM" Then
            If (isFileExist(astrRUN)) Then
                If ExecuteShell("""" & astrRUN & """") Then
                    If isFileExist(astrOUTPUT) Then
	                    WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, astrPARAM1 & " has generated an output file", G_LOG_FILE
	                    astrBuffer = LoadFile(astrOUTPUT, False)
                        atabLIST = Split(astrBuffer, "Page")
                        If Ubound(atabLIST) >= 1 Then
                            atabROWS = Split(atabLIST(1), Chr(13))
                            j = 1
                            aDblRAM = 0
                            While (j <= Ubound(atabROWS))
                                atabDATA = Split(deleteSpaceChar(atabROWS(j))," ")
                                If Ubound(atabDATA) >= 3 Then
                                    aDblRAM = aDblRAM + atabDATA(3)
                                End if
                                j = j + 1
                            Wend
                            If aDblRAM <> 0 Then
                                astrString = formatMemory(aDblRAM,1)
                            End if
                        End if
                    Else
	                    WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, astrPARAM1 & " has no output !!!", G_LOG_FILE
                    End if
                Else
                    WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, G_FOLDER_NAME & "cannot be launched because shells are stopped ...", G_LOG_FILE
                End if
            Else
                WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, G_FOLDER_NAME & "Batch cannot be found ...", G_LOG_FILE
            End if

        Elseif UCASE(astrPARAM2) = "UPTIME" Then
                strComputer = "."
                Set objWMIService = GetObject("winmgmts:" _
                    & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
                Set colOperatingSystems = objWMIService.ExecQuery _
                    ("Select * from Win32_OperatingSystem")
                For Each objOS in colOperatingSystems
                    dtmBootup = objOS.LastBootUpTime
                    dtmLastBootupTime =  CDate( Mid(dtmBootup, 7, 2) & "/" & _
                            Mid(dtmBootup, 5, 2) & "/" & Left(dtmBootup, 4) _
                            & " " & Mid (dtmBootup, 9, 2) & ":" & _
                            Mid(dtmBootup, 11, 2) & ":" & Mid(dtmBootup,13, 2))
                    dtmSystemUptime = Abs(DateDiff("N", dtmLastBootUpTime, Now))
                    strDays = (dtmSystemUptime \ 1440)
                    strHours = (dtmSystemUptime - (CLng(strDays) * 1440)) \ 60 
                    strMinutes = (dtmSystemUptime - (CLng(strDays) * 1440) - (CLng(strHours) * 60))  
                Next
                astrString = strDays & " Jour(s), " & strHours & " Heure(s), " & strMinutes & " Minute(s)"
                Set objWMIService = Nothing
                Set colOperatingSystems = Nothing

        Elseif UCASE(astrPARAM2) = "TOTALRAM" Then
                astrString = 0
                For Each objMem In GetObject("winmgmts:{impersonationLevel=impersonate}\\127.0.0.1\root\cimv2").InstancesOf("Win32_PhysicalMemory")
				    astrString = CLng(astrString) + CLng(objMem.Capacity/1024/1024)
			    next
                Set objMem = Nothing
                astrString = Cstr(astrString) & " Mo"

        Elseif UCASE(astrPARAM2) = "CPU" Then
                astrString = 0
			    For each objMem in GetObject("winmgmts:{impersonationLevel=impersonate}\\127.0.0.1\root\cimv2").InstancesOf("Win32_Processor")
				    astrString = objMem.LoadPercentage
			    next
                Set objMem = Nothing
                astrString = Cstr(astrString) & " %"
        Else
            WriteLog G_FOLDER_NAME, G_SCRIPT_INS, G_TIV_INF, astrLettre & astrCode & " cannot be triggered regularly !", G_LOG_FILE
        End if	
        SetDevice astrDevice, astrString, "", ""
		i = i + 1
	Wend
Else
	WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_SEV, "Expected Device is unknown !", G_LOG_FILE	
End if
WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "End of the script", G_LOG_FILE
End Sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> start the application
'-- PREREQUISITE: N/A
'-- PARAMS IN   : Device X10 device (House +Code)
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 29/03/2007
'--------------------------------------------------------------------
Sub startSoftware(paramDev)
Dim aG_SCRIPT_EVT 
Dim astrDevices
Dim astrConfig
Dim atabDv
Dim astrNbDv
Dim astrPARAM3
Dim astrRUN

aG_SCRIPT_EVT = "monitor.software (startSoftware)"
WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, "Launching " & aG_SCRIPT_EVT & " script", G_LOG_FILE
If CheckDevices(G_FOLDER_NAME, G_FILE_INI, G_STATUS_EXIST) Then
    If hs.DeviceExists(paramDev) <> -1 Then
		astrPARAM3			= hs.GetINISetting("DEVICE","PARAM3","",G_PATH_INI & "dev_" & paramDev & ".ini")	
        If astrPARAM3 <> "" Then
            astrRUN = generateBatFile(astrPARAM3, "start_" & paramDev) 
            If ExecuteShell(astrRUN) Then
            '   Well done
            Else
                WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_SEV, "error during BATch execution !", G_LOG_FILE    
            End if
        End if    
    Else
        WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_SEV, "Expected Device is unknown !", G_LOG_FILE	
    End if   
Else
	WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_SEV, "Expected Device is unknown !", G_LOG_FILE	
End if
WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, "End of the script", G_LOG_FILE
End sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> stop the application
'-- PREREQUISITE: N/A
'-- PARAMS IN   : Device X10 device (House +Code)
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 29/03/2007
'--------------------------------------------------------------------
Sub stopSoftware(paramDev)
Dim aG_SCRIPT_EVT 
Dim astrDevices
Dim astrConfig
Dim atabDv
Dim astrNbDv
Dim astrPARAM4
Dim astrRUN

aG_SCRIPT_EVT = "monitor.software (stopSoftware)"
WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, "Launching " & aG_SCRIPT_EVT & " script", G_LOG_FILE
If CheckDevices(G_FOLDER_NAME, G_FILE_INI, G_STATUS_EXIST) Then
    If hs.DeviceExists(paramDev) <> -1 Then
		astrPARAM4			= hs.GetINISetting("DEVICE","PARAM4","",G_PATH_INI & "dev_" & paramDev & ".ini")	
        If astrPARAM4 <> "" Then
            astrRUN = generateBatFile(astrPARAM4, "stop_" & paramDev) 
            If ExecuteShell(astrRUN) Then
            '   Well done
            Else
                WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_SEV, "error during BATch execution !", G_LOG_FILE    
            End if
        End if    
    Else
        WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_SEV, "Expected Device is unknown !", G_LOG_FILE	
    End if   
Else
	WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_SEV, "Expected Device is unknown !", G_LOG_FILE	
End if
WriteLog G_FOLDER_NAME, aG_SCRIPT_EVT, G_TIV_INF, "End of the script", G_LOG_FILE
End sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> format Memory
'-- PREREQUISITE: N/A
'-- PARAMS IN   : Memory as a string
'-- PARAMS OUT  : Formatted Memory
'-- CREATED BY DOMOTICS
'-- 29/03/2007
'--------------------------------------------------------------------
Function formatMemory(paramMEM, paramFACTOR)
Dim adblTmp
Dim atabMEM
Dim astrMEM

atabMEM = Split(paramMEM, " ")
If Ubound(atabMEM) >= 0 Then
    astrMEM = atabMEM(0)
    adblTmp = CDbl(astrMEM * paramFACTOR \ 1000) & " Mo"
Else
    adblTmp = "0 Mo"
End If
formatMemory = adblTmp
End Function